__package__    = "nfc.py"
__version__    = "1.0"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/growler/"
__cvsversion__ = "$Revision: 1.1 $"
__date__       = "$Date: 2007/12/28 08:36:33 $"
__copyright__  = "Copyright (c) 2007 Aaron Straup Cope. Perl Artistic License."

import sys

class probe :

    def __init__ (self, protocol) :

        self.__protocol = protocol
        self.__platform = sys.platform
        self.__handler = None
        self.__lastseen = None
        
        if protocol == 'bluetooth' :
            self.__init__bluetooth()
        else :
            raise Exception, "%s is not a supported protocol" % protocol
        
    #
    
    def __init__bluetooth (self) :

        if self.__platform == 'darwin' :
            import bluetooth.darwin
            self.__handler = bluetooth.darwin.probe()

        elif self.__platform == 'linux' : 
            import bluetooth.linux
            self.__handler = bluetooth.linux.probe()

        else :
            raise Exception, "%s is not a supported platform" % self.__platform

    #

    def is_device_nearby (self, address, timeout=15) : 
        return self.__handler.is_device_nearby(self.__lastseen, timeout)

    #

    def finddevices (self, timeout=15) :
        return self.__handler.finddevices(timeout)

    #
    
    def is_any_device_nearby (self, addrs, timeout=15) :

        if self.__lastseen :
            
            if self.__lastseen in addrs :
                if self.is_device_nearby(self.__lastseen, timeout) :
                    return self.__lastseen

                self.__lastseen = None

        devices = self.finddevices(timeout)

        if not devices :
            return None

        for addr in devices.keys() :
            if addr in addrs :
                self.__lastseen = addr
                return addr

        return None
